moved tests into test directory

This commit is contained in:
Emma Tebibyte 2024-04-24 14:58:35 -06:00
parent e7021e127c
commit 057f5571d6
Signed by: emma
GPG Key ID: 06FA419A1698C270
10 changed files with 134 additions and 82 deletions

View File

@ -40,10 +40,9 @@ install: dist
cp -r dist/* $(PREFIX)/
.PHONY: test
test: build
tests/posix-compat.sh
test: all
tests/test.sh
$(RUSTC) --test src/getopt-rs/lib.rs -o build/test/getopt
$(MAKE) -f Testfile
build/o/libsysexits.rlib: build
# bandage solution until bindgen(1) gets stdin support

View File

@ -1,78 +0,0 @@
#!/usr/bin/env make
# Copyright (c) 2024 DTB <trinity@trinity.moe>
# SPDX-License-Identifier: FSFAP
#
# Copying and distribution of this file, with or without modification, are
# permitted in any medium without royalty provided the copyright notice and this
# notice are preserved. This file is offered as-is, without any warranty.
BIN = build/bin
MAKE = make -B
DEFENDANTS = dj false intcmp strcmp true
.PHONY: all $(DEFENDANTS)
all: $(DEFENDANTS)
$(BIN)/dj:
$(MAKE) dj
$(BIN)/false:
$(MAKE) false
$(BIN)/intcmp:
$(MAKE) intcmp
$(BIN)/strcmp:
$(MAKE) strcmp
$(BIN)/true:
$(MAKE) true
dj: $(BIN)/dj $(BIN)/strcmp
sh -c "! $(BIN)/dj -h"
# This test is theoretically Linux-dependent; write(2) should return -1 on
# error.
# Right now dj(1) interprets the return value of write(2) as the amount of
# bytes written. This can decrement the stored quantity of bytes written,
# which is an int, so doesn't underflow but goes negative. dj(1) tries to
# again to write(2) if an error occurs in which no bytes are written, so in
# total two write(2)s are attempted and so the written byte quantity is -2.
# This is a bug and will change, but for now is at least documented.
sh -ec "\
$(BIN)/dj -Hi /dev/zero -o /dev/full \
| xargs -I out $(BIN)/strcmp '1+0 > 0+0; 1024 > -2' out"
# Read nothing from /dev/null, write nothing to /dev/null.
sh -ec "\
$(BIN)/dj -Hi /dev/null -o /dev/null \
| xargs -I out $(BIN)/strcmp '0+0 > 0+0; 0 > 0' out"
false: $(BIN)/false
sh -c "! $(BIN)/false"
sh -c "! $(BIN)/false -h"
intcmp: $(BIN)/intcmp
$(BIN)/intcmp -e 3 3 3
$(BIN)/intcmp -g 3 2 1
$(BIN)/intcmp -l 1 2 3
$(BIN)/intcmp -ge 3 3 1
$(BIN)/intcmp -le 1 3 3
$(BIN)/intcmp -gl 1 2 3
$(BIN)/intcmp -egl 3 1 1 2
sh -c "! $(BIN)/intcmp -e 1 2 3"
sh -c "! $(BIN)/intcmp -g 1 3 3"
sh -c "! $(BIN)/intcmp -l 3 3 1"
sh -c "! $(BIN)/intcmp -ge 1 2 3"
sh -c "! $(BIN)/intcmp -le 3 2 1"
sh -c "! $(BIN)/intcmp -gl 3 3 3"
sh -c "! $(BIN)/intcmp -egl foo"
strcmp: $(BIN)/strcmp
$(BIN)/strcmp equals equals
sh -c "! $(BIN)/strcmp inequals equals"
$(BIN)/strcmp - -
sh -c "! $(BIN)/strcmp -h"
sh -c "! $(BIN)/strcmp nocmp"
true:
$(BIN)/true
$(BIN)/true -h

25
tests/bonsai/dj.sh Executable file
View File

@ -0,0 +1,25 @@
#!/bin/sh
# Copyright (c) 2024 DTB <trinity@trinity.moe>
# Copyright (c) 2024 Emma Tebibyte <emma@tebibyte.media>
# SPDX-License-Identifier: FSFAP
#
# Copying and distribution of this file, with or without modification, are
# permitted in any medium without royalty provided the copyright notice and this
# notice are preserved. This file is offered as-is, without any warranty.
! dj -h
# This test is theoretically Linux-dependent; write(2) should return -1 on
# error.
# Right now dj(1) interprets the return value of write(2) as the amount of
# bytes written. This can decrement the stored quantity of bytes written,
# which is an int, so doesn't underflow but goes negative. dj(1) tries to
# again to write(2) if an error occurs in which no bytes are written, so in
# total two write(2)s are attempted and so the written byte quantity is -2.
# This is a bug and will change, but for now is at least documented.
dj -Hi /dev/zero -o /dev/full \
| xargs -I out "$BIN/strcmp" '1+0 > 0+0; 1024 > -2' out
# Read nothing from /dev/null, write nothing to /dev/null.
dj -Hi /dev/null -o /dev/null \
| xargs -I out "$BIN/strcmp" '0+0 > 0+0; 0 > 0' out

11
tests/bonsai/false.sh Executable file
View File

@ -0,0 +1,11 @@
#!/bin/sh
# Copyright (c) 2024 DTB <trinity@trinity.moe>
# Copyright (c) 2024 Emma Tebibyte <emma@tebibyte.media>
# SPDX-License-Identifier: FSFAP
#
# Copying and distribution of this file, with or without modification, are
# permitted in any medium without royalty provided the copyright notice and this
# notice are preserved. This file is offered as-is, without any warranty.
! false
! false -h

23
tests/bonsai/intcmp.sh Executable file
View File

@ -0,0 +1,23 @@
#!/bin/sh
# Copyright (c) 2024 DTB <trinity@trinity.moe>
# Copyright (c) 2024 Emma Tebibyte <emma@tebibyte.media>
# SPDX-License-Identifier: FSFAP
#
# Copying and distribution of this file, with or without modification, are
# permitted in any medium without royalty provided the copyright notice and this
# notice are preserved. This file is offered as-is, without any warranty.
intcmp -e 3 3 3
intcmp -g 3 2 1
intcmp -l 1 2 3
intcmp -ge 3 3 1
intcmp -le 1 3 3
intcmp -gl 1 2 3
intcmp -egl 3 1 1 2
! intcmp -e 1 2 3
! intcmp -g 1 3 3
! intcmp -l 3 3 1
! intcmp -ge 1 2 3
! intcmp -le 3 2 1
! intcmp -gl 3 3 3
! intcmp -egl foo

14
tests/bonsai/strcmp.sh Executable file
View File

@ -0,0 +1,14 @@
#!/bin/sh
# Copyright (c) 2024 DTB <trinity@trinity.moe>
# Copyright (c) 2024 Emma Tebibyte <emma@tebibyte.media>
# SPDX-License-Identifier: FSFAP
#
# Copying and distribution of this file, with or without modification, are
# permitted in any medium without royalty provided the copyright notice and this
# notice are preserved. This file is offered as-is, without any warranty.
strcmp equals equals
! strcmp inequals equals
strcmp - -
strcmp -h
! strcmp nocmp

11
tests/bonsai/true.sh Executable file
View File

@ -0,0 +1,11 @@
#!/bin/sh
# Copyright (c) 2024 DTB <trinity@trinity.moe>
# Copyright (c) 2024 Emma Tebibyte <emma@tebibyte.media>
# SPDX-License-Identifier: FSFAP
#
# Copying and distribution of this file, with or without modification, are
# permitted in any medium without royalty provided the copyright notice and this
# notice are preserved. This file is offered as-is, without any warranty.
true
true -h

13
tests/posix/false.sh Executable file
View File

@ -0,0 +1,13 @@
#!/bin/sh
# Copyright (c) 2024 DTB <trinity@trinity.moe>
# Copyright (c) 2024 Emma Tebibyte <emma@tebibyte.media>
# SPDX-License-Identifier: FSFAP
#
# Copying and distribution of this file, with or without modification, are
# permitted in any medium without royalty provided the copyright notice and this
# notice are preserved. This file is offered as-is, without any warranty.
alias false="$BIN/false"
! false
! false -h

13
tests/posix/true.sh Executable file
View File

@ -0,0 +1,13 @@
#!/bin/sh
# Copyright (c) 2024 DTB <trinity@trinity.moe>
# Copyright (c) 2024 Emma Tebibyte <emma@tebibyte.media>
# SPDX-License-Identifier: FSFAP
#
# Copying and distribution of this file, with or without modification, are
# permitted in any medium without royalty provided the copyright notice and this
# notice are preserved. This file is offered as-is, without any warranty.
alias true="$BIN/true"
true
true -h

View File

@ -9,13 +9,34 @@
set -e
export BIN=build/bin
if ! ls Makefile >/dev/null 2>&1
then
printf '%s: Run this script in the root of the project.\n' "$0" 1>&2
exit 1
fi
printf "Starting POSIX compatibility testing.\n"
printf "Starting Bonsai testing.\n\n"
for script in tests/bonsai/*.sh; do
export UTIL="$(printf '%s\n' "$script" \
| sed -e 's/\.sh//g' -e 's;tests\/bonsai\/;;g')"
alias "$UTIL"="$BIN/$UTIL"
printf '%s: %s: Testing utility.\n' "$0" "$UTIL"
"$script"
printf '\n'
done
if ! ls Makefile >/dev/null 2>&1
then
printf '%s: Run this script in the root of the project.\n' "$0" 1>&2
exit 1
fi
printf "Starting POSIX compatibility testing.\n\n"
for utility in tests/posix/*; do
printf '%s: %s: Testing utility.\n' "$0" "$utility"